 .nolist				;defines, includes, and equates
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#include "ti83asm.inc"		;ROM call definitions
#include "tokens.inc"		;token interpretation
_io_exec .equ $51EF
_CreateProg	.equ	$448A
.list
	.org $9327
	xor d
	jr Start
	.dw 0
	.db $05,$00
	.dw Icon
	.dw 0
Start:
	call $91A7+(9*3)
	call $91A7+(8*3)
	ld a,8
	ld (PENROW),a
	inc a
	ld (PENCOL),a
	ld hl,CreatePwdTxt
	set TextInverse,(iy+TextFlags)
	call _vputs
	res TextInverse,(iy+TextFlags)
	ld a,17
	ld (PENROW),a
	ld a,10
	ld (PENCOL),a
	ld hl,EnterPwd2
	call _vputs
	ld a,30
	ld (PENROW),a
	ld a,9
	ld (PENCOL),a
	ld hl,ReEnterPwd
	call _vputs
	ld a,24
	ld (PENROW),a
	ld a,11
	ld (PENCOL),a
	call GetPwd
	ld hl,Password
	ld de,TempArea2
	ld bc,8
	ldir
	ld a,37
	ld (PENROW),a
	ld a,11
	ld (PENCOL),a
	call GetPwd
	ld b,8
	ld hl,Password
	ld de,TempArea2
CpLoop:
	ld a,(de)
	cp (hl)
	jr nz,NoGood
	inc hl
	inc de
	djnz CpLoop
	ld hl,SEText
	rst 20h
	call _chkfindsym
	ret nc
	ld hl,EndSEData-StartSEData
	push hl
	call _createprog
	inc de
	inc de
	ld hl,StartSEData
	pop bc
	ldir
	ret
NoGood:
	ld a,44
	ld (PENROW),a
	ld a,10
	ld (PENCOL),a
	ld hl,Mismatch
	call _vputs
	jp _Getkey
GetPwd:
	ld hl,Password
	ld b,8
LoadPwdLoop:
	push hl
	call _getkey
	pop hl
	cp 5
	jr z,Done
	push hl
	push af
	ld hl,Star2
	call _vputs
	ld hl,PenCol
	dec (hl)
	dec (hl)
	pop af
	pop hl
	ld (hl),a
	inc hl
	djnz LoadPwdLoop
Done:
	ld hl,Space
	call _vputs
	ret

StartSEData:
SEStart:
	.db $AB
	.db $31
	.db $87
	.db $50
	.dw SELoad-SEStart
	.dw 0
	.dw 0
SELoad:
	call _grbufclr
	call _clrlcdfull
	call _clrtxtshd
	call _homeup
LoadPwd:
	ld hl,EnterPwd2-SELoad+$8265
	call _puts
	call _newline
	ld hl,Star2-SELoad+$8265+1
	call _puts
	ld hl,CurCol
	dec (hl)
GetPwd2:
	ld hl,TempData-SELoad+$8265
	ld b,8
LoadPwdLoop2:
	push hl
	call _getkey
	pop hl
	cp 5
	jr z,Done2
	push hl
	push af
	ld hl,Star2-SELoad+$8265
	call _puts
	ld hl,CurCol
	dec (hl)
	pop af
	pop hl
	ld (hl),a
	inc hl
	djnz LoadPwdLoop2
Done2:
	ld b,8
	ld hl,TempData-SELoad+$8265
	ld de,Password-SELoad+$8265
CpLoop2:
	ld a,(de)
	cp (hl)
	jr nz,NoGood2
	inc de
	inc hl
	djnz CpLoop2
	ld e,0
	ret
NoGood2:
	call _newline
	ld hl,Incorrect-SELoad+$8265
	call _puts
	call _getkey
	ld e,1
	ret
Incorrect:
	.db "Incorrect!",0
Star2:
	.db "*|",0
EnterPwd2:
	.db "Enter Password:",0
TempData:
	.db 0,0,0,0,0,0,0,0
Password:
	.db 0,0,0,0,0,0,0,0
EndSEData:

Space:
	.db " ",0
SEText:
	.db 5,$23,"PW",0
CreatePwdTxt:
	.db " Set Password",0
ReEnterPwd:
	.db " Reenter password:",0
MisMatch:
	.db "Mismatch!",0
TempArea2:
	.db 0,0,0,0,0,0,0,0
Icon:
	.db $1C,$CC,$3F,$26,$47,$16,$B3,$16
	.db $B3,$16,$83,$97,$41,$FF,$3C,$EB
	.db $0C,$7B,$0B,$3B,$0B,$3B,$0A,$EB
	.db $0A,$AB,$0A,$AB,$0A,$AB,$0F,$FE
.end
END